<?php

namespace FiloBlu\Referrals\Model\Config\Source;

use Magento\SalesRule\Model\ResourceModel\Rule\CollectionFactory;


class Salesrule implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var \Magento\SalesRule\Model\ResourceModel\Rule\CollectionFactory
     */
    protected $collectionFactory;

    public function __construct(
        CollectionFactory $collectionFactory
    )
    {
        $this->collectionFactory = $collectionFactory;
    }

    public function toOptionArray()
    {
        $options = $this->collectionFactory->create()->addIsActiveFilter()->toOptionArray();
        $sorted_options = usort($options, array($this, "compare"));
        $prepend_element = ['value' => '', 'label' => 'Select rule'];
        array_unshift($options, $prepend_element);

        return $options;
    }

    public function compare($a, $b) {
        return strcasecmp($a['label'], $b['label']);
    }
}